#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar  4 11:38:41 2022

@author: felix
"""

import numpy as np
import time
class Timer:
    def __init__(self):
        self.elapsedTime = 0.
    def start(self):
        self._start_time = time.perf_counter()
    def stop(self):
        stopTime = time.perf_counter()
        self.elapsedTime += stopTime - self._start_time
    


def fillALargeArrayPython(number):
    vector = np.zeros(number)
    
    for i in range(number):
        vector[i] = i*0.123 + np.sqrt(i)
        
    return vector


from CythonFile import fillLoop
def fillALargeArrayCython(number):
    vector = np.zeros(number)
    
    fillLoop(vector)
    
    return vector

pythonTimer = Timer()
cythonTimer = Timer()

pythonTimer.start()
a = fillALargeArrayPython(int(5e6))
pythonTimer.stop()

cythonTimer.start()
b = fillALargeArrayCython(int(5e6))
cythonTimer.stop()

difference = np.linalg.norm(a-b)

print(f'Python requires {pythonTimer.elapsedTime} s')
print(f'Cython requires {cythonTimer.elapsedTime} s')

print(f'The results are identical, see |a-b| = {difference}')